/*
 *  fileops.h
 *  CocoaDU
 *
 *  Created by Matthijs on Tue Jan 06 1970.
 *  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef FILEOPS_H_INCLUDED
#define FILEOPS_H_INCLUDED

struct stat;


#define FN_STAT_ERROR 1
#define FN_STAT_DIR 2
#define FN_STAT_SYMLINK 4
#define FN_STAT_OTHER 8
#define FN_STAT_RSRC_ERROR 16
#define FN_OPENDIR_ERROR 32

struct FileNode {
  int flags; /* stat error ? dir ? special file ? */
 
  unsigned long size;  
  /* in 512 byte blocks, including children for directories */
 
  unsigned long d_size; /* data size, in bytes */
  unsigned long r_size; /* ressource size, in bytes */  
  int depth;            /* subdir depth 0=file */

  /* tree fields */
  struct FileNode *next;
  struct FileNode *children;
  
  /* remember stat field */
  struct stat *st;
 
  char name[1];         /* to alloc the struct with 1 malloc */
};


struct FileNode *explore_tree(
  char *root);

void dealloc_tree(struct FileNode *fn);

#endif

